#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void abort(void);
extern "C" void exit(int status);
#endif

#include 	<stdio.h>
#include        "compilerApi.h"
#include        "global_var.h"
#include 	"basic_fun.h"
#define         IDSTR   "BD"
#define         NOT_DECIDED -10
#define         DECIDED 10

int	array_to_forall(SgStatement *,SgStatement *);
//change the array assign statement to forall statement

int     where_to_forall(SgStatement *,SgStatement*);
//change the where statement to forall statement

int	trans_b1(SgStatement *, SgExpression *,SgExpression *,SgStatement*);
int 	scalarize_exp(SgStatement *,SgExpression *,SgExpression **,int,
			 SgSubscriptExp **,SgStatement*);
//scalarize the given exp to scalar form,some time we need the subscript 
//of the exp ,int variable denote the start index variable number.


SgExpression *scalarize_AryRef_exp(SgStatement *,SgExpression *,int,SgExpression **,int,SgSubscriptExp**,int *,SgStatement*);
//scalarize the given array reference variable and return forall header if 
//set forall flag sometime we need subscript and the another int variable 
//is used for index variable digit

SgExpression *b1_change_lhs(SgStatement *,SgExpression* ,SgExpression **,SgStatement *);
//change the left hand of array assign statement to scalarized form and get forall header

int is_function(SgExpression *);
//if the expression is any form of function call or function reference or user defined operator 

int 	if_trans(SgStatement *);
//if we need to change the statement
SgExpression * get_constructor_num(SgExpression * );//array constructor have how many elements
SgExpression * ac_implied_do(SgExpression * );//the implied do variable repeats how many times repeat
SgExpression * ac_value_list(SgExpression * );//the ac_value_list has how many elements 
SgType * array_exp_type(SgExpression * ,int *); // get the exp's type .
int get_subscript(SgExpression *,SgSubscriptExp**,int *flag);
//if the expression is array expression ,get its low bound ,up bound and
//step , return its dimension,elst return 0 represent scalar expression.
//here we only consider one dimension.

int  add_align_for_tmp(SgStatement * hedr_stmt,SgSymbol *tmp,SgExpression *argexp);
extern int align_where_condition(SgStatement *hedr_stmt,SgSymbol *tmp, SgSymbol *align_target);
int     isBinaryOp(SgExpression *);
int	contain(SgExpression *,SgSymbol *);

void	align_temp_var(SgStatement *,SgExpression *,SgExpression *,
			SgExpression *);
//make temperary variable align with ...

SgExpression	*temp_array_list;

#define Scalar_Assign  100
	

/***************************************************************************
	int  element_to_array(SgStatement *hedr_stmt,SgStatement *current)

        change array element of lhs to array section like: a(i) => a(i:i)
****************************************************************************/

//  change array ref  a(4) => a(4:4)
void     change_array_ref(SgExpression *arrayref)
{
	int dim=0;
	SgExpression *subscript=arrayref->lhs();
	for ( ; subscript ; subscript=subscript->rhs() ,dim++)
	{
		SgExpression *index=subscript->lhs();
		// if already is subscript
		if (isSgSubscriptExp(index)) continue;
		SgSubscriptExp *new_index=new SgSubscriptExp(*index,index->copy());
		subscript->setLhs(new_index);
	}
	if (isSgArrayType(arrayref->type()) == NULL )
	{
		SgArrayType *new_type = new SgArrayType(*(arrayref->type()));
		new_type->thetype->entry.ar_decl.num_dimensions=dim;
		arrayref->setType(*new_type);
	}
}

void change_rhs(SgExpression *exp)
{
	if ( exp == NULL ) return;
	switch ( exp->variant() == ARRAY_REF)  {
	case ARRAY_REF: {
		change_array_ref(exp);
		break;
		}
		// donot touch function arguments
	case INTRIN_FUNC_CALL:
	case FUNC_CALL:
		break;
	default: 	{
		if ( exp->lhs() )  change_rhs(exp->lhs());
		if ( exp->rhs() )  change_rhs(exp->rhs());
		break;
		}
	}
}

// change array element of lhs to array section like: a(i) => a(i:i)
int	element_to_array(SgStatement *hedr_stmt,SgStatement *current)
{
	SgExpression	*lhs,*rhs;	

	// check if not in forall assignment
	switch (current->controlParent()->variant() )
	{
	case FORALL_STMT:
	case FORALL_CONSTRUCT_STMT:
//	case FOR_NODE:
		 return 0;
	}

	lhs=current->expr(0);
	rhs=current->expr(1);
        //right hand side of the current assign statement. 
	SgType *type=lhs->type();
	// only deal with scalar array reference.
	if (!isSgArrayType(type) && lhs->variant() == ARRAY_REF)
	{
//      	if(rhs->variant()==INTRIN_FUNC_CALL && ((SgFunctionSymb *)rhs->symbol())->is_elementary_function() ) return 0;
		// change the lhs part of the assign statement
		change_array_ref(lhs);
		// change the rhs part of the assign statement
		change_rhs(rhs);
		current->addAttribute(Scalar_Assign, NULL,0);
	}
	return 1;
}


/************************************************************************
	int  expression_extract(SgStatement *hedr_stmt,SgStatement *current)

	 move expression in intrinsic call argument as temp array.
**************************************************************************/

int expression_extract(SgStatement *hedr_stmt,SgStatement *current);

void intrin_exp(SgStatement *hedr_stmt,SgStatement *current,SgExpression *exp)
{
	SgFunctionCallExp *funcall = (SgFunctionCallExp *)exp;
	// check every dummy
	for (int i=0 ; i< funcall->numberOfArgs() ; i++ )
	{
		SgExpression *argexp = funcall->arg(i);

		if (argexp->variant() == KEYWORD_ARG)
			argexp = argexp->lhs();
		SgArrayType *type = isSgArrayType(argexp->type());
		if (type == NULL) continue;
		switch (argexp->variant() ) {
		case VAR_REF:
		case ARRAY_REF:
		case CONST_REF:
			continue;
		}

		SgAssignStmt *aassign;
                SgSymbol *tmp=get_temp_variable(hedr_stmt,type,"AR");
		SgExpression *expr = new SgVarRefExp(tmp);
		expr->setType(*type);
		if (type->getDimList())
		{
                add_align_for_tmp(hedr_stmt,tmp,argexp);
                SgStatement *decl_stmt=tmp->makeVarDeclStmt();
		SgStatement *last_decl=hedr_stmt->firstStmtForDeclaration();
                last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
		}
		else {
		  // the size of tmp cannot be decided, must allocate the array
		tmp->setAttribute(ALLOCATABLE_BIT);
		SgStatement *last_decl=hedr_stmt->firstStmtForDeclaration();
		SgVarListDeclStmt *alloc = new SgVarListDeclStmt(ALLOCATABLE_STMT, *expr->copyPtr());
                last_decl->insertStmtAfter(*alloc,*hedr_stmt);
                SgStatement *decl_stmt=tmp->makeVarDeclStmt();
                last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
		// not finished yet 
		// to add allocate and deallocate stmt
		ASSERT(0);
		}
		aassign=new SgAssignStmt(*expr,*argexp->copyPtr());
		argexp->replace(*expr->copyPtr());
		current->insertStmtBefore(*aassign,*current->controlParent());
		  // recursively extract expression
		expression_extract(hedr_stmt,aassign);
		array_to_forall(hedr_stmt,aassign);
	}
}

int expression_deal(SgStatement *hedr_stmt,SgStatement *current,SgExpression *exp)
{
	switch (exp->variant()) {
	case INTRIN_FUNC_CALL:
		intrin_exp(hedr_stmt,current,exp);
		break;
	default:
		if (exp->lhs()) expression_deal(hedr_stmt,current,exp->lhs());
		if (exp->rhs()) expression_deal(hedr_stmt,current,exp->rhs());
		break;
	}
	return 1;
}

//expression_extract(main)
int expression_extract(SgStatement *hedr_stmt,SgStatement *current)
{
	SgExpression *rhs = current->expr(1);
	expression_deal(hedr_stmt,current,rhs);
	return 1;
}

/*************************************************************************
	extract_intrinisc_function()

	extract intrinsic function call (return scalar result) from assign 
	statement as:

	T=sum(...)	( T is temparory variable)
*************************************************************************/

void extract_intrinsic_calls(SgStatement *hedr_stmt, SgStatement *current,SgExpression *exp)
{
	switch (exp->variant())
	{
	case INTRIN_FUNC_CALL: {
		SgType *type = exp->type();
		if (isSgArrayType(type) != NULL) return;
                SgSymbol *tmp=get_temp_variable(hedr_stmt,type,"INR");
                SgStatement *decl_stmt=tmp->makeVarDeclStmt();
		SgStatement *last_decl=hedr_stmt->firstStmtForDeclaration();
                last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
		SgExpression *expr = new SgVarRefExp(tmp);
		expr->setType(*type);
		SgAssignStmt *aassign=new SgAssignStmt(*expr,*exp->copyPtr());
		current->insertStmtBefore(*aassign,*current->controlParent());
		exp->replace(*expr->copyPtr());
		break;
	  }
	default: {
		SgExpression *lhs = exp->lhs();
		if (lhs) extract_intrinsic_calls(hedr_stmt,current,lhs);
		SgExpression *rhs = exp->rhs();
		if (rhs) extract_intrinsic_calls(hedr_stmt,current,rhs);
	  }
	}
}

void extract_intrinsic_function(SgStatement *hedr_stmt,SgStatement *current)
{
	SgExpression *rhs = current->expr(1);
	if (rhs->variant() ==  INTRIN_FUNC_CALL) return;
	extract_intrinsic_calls(hedr_stmt,current,rhs);
}

/************************************************************************/

//
//change array assign statement to foral statement
//
int	array_to_forall(SgStatement *hedr_stmt,SgStatement *current)
{	
	SgExpression	*lhs,*rhs;	
	SgType	*type;

	lhs=current->expr(0);
	//left hand side of the current assign statement. 
	rhs=current->expr(1);
        //right hand side of the current assign statement. 
	type=lhs->type();
        //the type of left hand side of the current assign statement. 
	if  (isSgArrayType(type))
	//only transform ARRAY assign statement
	{	
		if (if_trans(current))
		//if need transform this kind of array assign statement
		// A=f(b) do not need to change.
			trans_b1(hedr_stmt,lhs,rhs,current);	
	}
	return	0;
}

//
//  transform the left hand side of the array assign statement ,get the 
//scalarized lhs and forall header.lhs_res is the outcome of the lhs
//
SgExpression	*b1_change_lhs(SgStatement *hedr_stmt, SgExpression  *lhs,
		SgExpression **lhs_res,SgStatement *current)
{	SgSubscriptExp * subscript;
	int scalarized_dim;
	return scalarize_AryRef_exp(hedr_stmt,lhs,1,lhs_res,0,&subscript,&scalarized_dim,current);
//here we do not use the result of subscript.
// flag 1 means calculate forall header,0 means index variable digit start from 0
}


//   modified lbound ubound
//        cur_exp //the expression to be scalarized
int   get_lubound(int i_dim,SgExpression *cur_exp,SgExpression *&lbound,SgExpression *&ubound,SgExpression *&step)
{
	SgVariableSymb	*temp_sym;
	if (lbound==NULL||ubound==NULL||step==NULL)
	{
		if (!lbound) 
		{
			lbound=new SgValueExp(i_dim+1);
			lbound=new SgExpression(EXPR_LIST,lbound,NULL,NULL);
			SgExpression *array = new SgVarRefExp(cur_exp->symbol());
                       	lbound=new SgExpression(EXPR_LIST,array,lbound,NULL);
			temp_sym=new  SgVariableSymb("lbound");
                       	lbound=new SgExpression(INTRIN_FUNC_CALL,lbound,NULL,temp_sym);
			lbound->setType(*SgTypeInt());
		}
		if (!ubound)
		{
                       	ubound=new SgValueExp(i_dim+1);
                       	ubound=new SgExpression(EXPR_LIST,ubound,NULL,NULL);
			SgExpression *array = new SgVarRefExp(cur_exp->symbol());
                       	ubound=new SgExpression(EXPR_LIST,array,ubound,NULL);
                       	temp_sym=new  SgVariableSymb("ubound");
                       	ubound=new SgExpression(INTRIN_FUNC_CALL,ubound,NULL,temp_sym );
			ubound->setType(*SgTypeInt());
		}
		if (!step)
			step=base_step;

	}
	return 1;
}

//
//  scalarize an ARRAY REFERENCE EXPRESSION,like A,A(B),A%B%C,B(1:1000:3)...
// exp_res is the output of the exp
//
SgExpression *scalarize_AryRef_exp(SgStatement *hedr_stmt,SgExpression *exp, 
	int forall_trip,SgExpression **exp_res,int index_var,SgSubscriptExp ** sub_res,int *scalarized_dim_res,SgStatement *current)
{
//scalarize exp to * exp_res, if set forall_trip,get forall header and 
//retun it
	SgVariableSymb	*array_name;//the rightest variable name or array
					// subobject name.
	SgVariableSymb  *sub_array_name;//like array name ,used in subscript
	SgSubscriptExp	*subscript;//the subscript expression of i dimension
	SgArrayType	*array_type;//the type of array name
	SgArrayType	*sub_array_type;//like array_type,used in subscript
	SgExpression	*expr_list;//subscript expression list
	SgExpression    *lbound , *ubound, *step;// the low bound,up bound,
						// and step of i dimension
	SgExpression	*forall_end_sub;//the up value expression of forall subscript
	SgSubscriptExp  *forall_sub;// forall subscript
	SgIndexOpExp    *forall_triplet;//forall triplet
	SgExpression    *forall_header;//foral header
	SgExpression    *forall_triplet_spec,*forall_triplet_spec1,*tail;
			//hold forall_triplet_spec
	int 		i_dim;//the i dimension of array name
	int		total_dim;//how many dimension of array name
//	int		sub_dim=0;
//	int 		index_var=-1;//denote the temporary index variable
	int 		scalarized_dim=0;//the rank of the array reference expression
	int			scalar_or_array;
//	SgExpression 	*cur_exp=exp;//the expression to be scalarized
        SgExpression    *cur_exp;//the expression to be scalarized

	SgExpression	*rec_exp;//record reference expression	
	SgVarRefExp     *index_exp;//the index variable
	SgExpression	*temp1,*temp;
	SgExpression	*sub;// hold the scalarized subscript
	SgExpression	*ary_constructor,* range;
    	SgType          *type;
	SgVariableSymb	*temp_sym;
	SgStatement	*decl_stmt,*last_decl;
	SgExpression	*exp1,*exp2,*exp3,*exp4;
	SgExprListExp	*exp5;
	SgVarRefExp	*var_exp;
	SgExpression	*ary_sub,*ary_sub_res;//used when array subscript is int expression

	// initial forall header variable
	cur_exp=exp->copyPtr();
	exp=cur_exp;
	forall_header=NULL;
	forall_triplet_spec=NULL;
	// reduce RECORD_REF to ARRAY_REF,get the rightest expression if record
	if (isSgRecordRefExp(cur_exp)) {
		int the_variant;
		the_variant=cur_exp->lhs()->type()->variant();
		while (cur_exp->rhs()) {
			if (the_variant!=T_ARRAY)
			{	cur_exp=cur_exp->rhs();
                		the_variant=cur_exp->lhs()->type()->variant();
			}else
			{  break;
			}
		}
		rec_exp=cur_exp;              // save this pointer !!
		cur_exp=cur_exp->lhs();
		// this means the cur_exp point to the RECORD_REF and the record name itself is an arraytype 
		if (rec_exp == exp) {
			rec_exp=exp;
			//cur_exp=rec_exp->lhs();
			cur_exp=rec_exp;
		}
		// now RECORD_REF is reduced to VAR_REF or ARRAY_REF in cur_exp.
	}
	expr_list=cur_exp->lhs();                   // subscipt list

	array_name=(SgVariableSymb *) (cur_exp->symbol());
	array_type=(SgArrayType *) (array_name->type());

        *exp_res=new SgArrayRefExp(*array_name);    // new ARRAY_REF produced

	total_dim=array_type->dimension();               // dimension

	for (i_dim=0;i_dim<total_dim;i_dim++) {

       	  index_exp=new SgVarRefExp(get_temp_index(index_var++,hedr_stmt,IDSTR));

	  subscript=(SgSubscriptExp *)array_type->sizeInDim(i_dim);
	  if (isSgVarRefExp(cur_exp)) {
	  	// form like A,A%B,...
		if (subscript)
		{
		ubound=(subscript->ubound());
		lbound=(subscript->lbound());
		step=(subscript->step());
		lbound = calculateExp(lbound);
		}
		else {
		lbound = NULL;
		}

		if (lbound==NULL||ubound==NULL)
		{
			lbound=new SgValueExp(i_dim+1);
			lbound=new SgExpression(EXPR_LIST,lbound,NULL,NULL);
                        lbound=new SgExpression(EXPR_LIST,cur_exp,lbound,NULL);
			temp_sym=new  SgVariableSymb("lbound");
                        lbound=new SgExpression(INTRIN_FUNC_CALL,lbound,NULL,temp_sym);
			lbound->setType(*SgTypeInt());
                        ubound=new SgValueExp(i_dim+1);
                        ubound=new SgExpression(EXPR_LIST,ubound,NULL,NULL);
                        ubound=new SgExpression(EXPR_LIST,cur_exp,ubound,NULL);
                        temp_sym=new  SgVariableSymb("ubound");
                        ubound=new SgExpression(INTRIN_FUNC_CALL,ubound,NULL,temp_sym );
			ubound->setType(*SgTypeInt());

			step=base_step;

		}
 	        sub=& ((*lbound)+(*index_exp)*(*step));
        	((SgArrayRefExp *)(*exp_res))->addSubscript(*sub);
		*sub_res=subscript;
		scalarized_dim++;
	  }//end of VarRefExp
	  else 
	  if (expr_list->lhs()->variant()==DDOT){
		// form like A(1:10:2),A(1:10),A(1:),A(:10:2),A(1::2),A(::2),...

		temp=expr_list->lhs();//DDOT expression
		temp1=temp->rhs();//step expr
		if (temp1) {step=temp1;}//initial value
		    else {step=base_step;}//default
		temp=temp->lhs();//RANGE expression
		temp1=temp->lhs();//low bound expression
		if (temp1) {lbound=temp1;}//initial value
		    else {lbound=(subscript->lbound());}//defined array variable's lbound
		  temp1=temp->rhs();//up bound expression
		   if (temp1)  { ubound=temp1; }//initial value
		     else 	{ubound=(subscript->ubound());}//defined array variable's ubound
		get_lubound(i_dim,cur_exp,lbound,ubound,step);
		expr_list=expr_list->rhs();// expr_list now point to the next dimension
 	        sub=& ((*lbound)+(*index_exp)*(*step));
        	((SgArrayRefExp *)(*exp_res))->addSubscript(*sub);
		*sub_res=new SgSubscriptExp(*lbound,*ubound,*step);   
		scalarized_dim++;

	  }//end of DDOT
	  else
	  {
		  // array or scalar expression:
		  // Vector subscript like A((/1,2,3/)),scalar subscript like A(i,:)
		  // array expression like A(B+C),B and C are one dimension array,vector subscript is
		  //one dimension int array expression.
		  ary_sub=expr_list->lhs();
		  expr_list=expr_list->rhs();//point to the next dimension subscript
		  scalar_or_array=scalarize_exp(hedr_stmt,ary_sub,&ary_sub_res,index_var-1,&subscript,current);
		  scalarized_dim+=scalar_or_array;
		  sub=ary_sub_res;
		  *sub_res=subscript;
		  if (scalar_or_array==0){
			
			//ary_sub is scalar expression
			index_var--;
			((SgArrayRefExp *)(*exp_res))->addSubscript(*sub);
		  	continue;
		  }else
		  {
			//ary_sub is array expression
			//specification restrict the ary_sub must be rank=1 integer array expression
			//only here we use the subscript calculated by  scalarize_exp(....)
			ubound=(subscript->ubound());
		  	lbound=(subscript->lbound());
		      	step=(subscript->step());
        	  	((SgArrayRefExp *)(*exp_res))->addSubscript(*sub);
			get_lubound(i_dim,cur_exp,lbound,ubound,step);
		  }
	  }//end of int_expr subscript

	//sub=& ((*lbound)+(*index_exp)*(*step));
	//  ((SgArrayRefExp *)(*exp_res))->addSubscript(*sub);

	// generate forall header's triplet spec
	if (forall_trip) {
		// check if is scalar assignment
		if (current->numberOfAttributes(Scalar_Assign) != 0)
	  		forall_end_sub= new SgValueExp(0);
		else {
			int val;
	 		forall_end_sub= &(((*ubound)-(*lbound))/(*step));
			// check if we can caculate the forall_end_sub
			if (forall_end_sub->isInteger())  {
				val=forall_end_sub->valueInteger();
				forall_end_sub= new SgValueExp(val);
			}
			else if (step != base_step )
	  			forall_end_sub= &(((*ubound)-(*lbound))/(*step));
			     else
	  			forall_end_sub= &((*ubound)-(*lbound));
		}
		// index_sub=new SgSubscriptExp(*base_lbound,*end,*base_step);
          	forall_sub=new SgSubscriptExp(*base_lbound,*forall_end_sub);
	  	forall_triplet=new SgIndexOpExp(*index_exp,*forall_sub);
	  	forall_triplet_spec1=new SgExpression(CONTROL_LIST,forall_triplet,NULL,NULL,NULL);
	  	if (!forall_triplet_spec)  {
			forall_triplet_spec=tail=forall_triplet_spec1;
	  	}
	  	else {
	  		tail->setRhs(forall_triplet_spec1);
			tail=forall_triplet_spec1;
	  	}
	}   // end of if(forall_trip)
    	}  // end of for loop

	if (forall_trip)
	forall_header=new SgExpression(FORALL_HEADER_OP,forall_triplet_spec,NULL,NULL,NULL);

	if (isSgRecordRefExp(exp)) {
		rec_exp->setLhs(*exp_res);
		*exp_res=exp;                  // retrieve the pointer !
	}
	*scalarized_dim_res=scalarized_dim;
	return forall_header;
}



//
//this function transform given ARRAY assign statement to forall statement
//given statement if lhs ,rhs is the transformed result.
//
int	trans_b1(SgStatement  *hedr_stmt,SgExpression *lhs,SgExpression *rhs,SgStatement *current)
{
	SgAssignStmt	*aassign;
	SgForallStmt	*aforall;
	SgVarRefExp	*index_exp;
	SgExpression	*index_trip;
	SgVariableSymb	*temp;
	SgExpression    *lhs_res,*rhs_res;
	SgSubscriptExp	*subscript;
//change the left hand
	index_trip=b1_change_lhs(hedr_stmt,lhs,&lhs_res,current);
//we do not introduce ALIGN directive when pass lhs.
//change the right hand
	temp_array_list=NULL;
	scalarize_exp(hedr_stmt,rhs,&rhs_res,0,&subscript,current);
//generate align directive statement if temp_array_list is not NULL
	align_temp_var(hedr_stmt,index_trip,lhs_res,temp_array_list);
//generate scalarized assign statement
	aassign=new SgAssignStmt(*lhs_res,*rhs_res);
//generate forall statement
	aforall= new  SgForallStmt(*index_trip,*aassign); 
//replace the old ARRAY assign statement with forall statement
//	current->replaceWithStmt(*aforall);
	current->insertStmtAfter(*aforall,*current->controlParent());
	current->deleteStmt();

	return	1;
}

//
// scalarize any expression ,if it is scalar,keep no change;if array,change it
// exp is the given expression , exp_res is the transformed result of the exp
///

int scalarize_exp(SgStatement *hedr_stmt, SgExpression *exp,SgExpression **exp_res,int index_var,SgSubscriptExp **subscript,SgStatement *current)
{

	SgExpression	*left_tree,*right_tree,*left_res,*right_res,*sub;
	SgExpression	*cur_exp=(exp),*temp_exp,*temp_exp1;
	SgVariableSymb	*var_sym;
	SgExpression	*ubound,*lbound,*step;
	int		scalarized_dim=0,total_dim,i_dim;
	int		l_scalarized_dim,r_scalarized_dim;
	SgType		*type;
        SgStatement     *decl_stmt,*control_parent,*last_stmt,*allocate_stmt,*deallocate_stmt;
	SgExpression	*exp1,*exp2,*exp3,*exp4,*range;
	SgExprListExp	*expr_list;
	SgVarRefExp 	*index_exp;
	SgStatement	*last_decl;
	SgAssignStmt	*assign_stmt;
	SgVarRefExp	*var_ref_exp;
	SgArrayRefExp	*ary_ref_exp;
	
       int             decided_dim=NOT_DECIDED;

        SgExpression *head_exp;
        SgArrayType *ary_type;

	if (is_function(cur_exp))
	{
		if (cur_exp->variant() == FUNC_CALL)
		type=cur_exp->symbol()->type();
		else 
		type=cur_exp->type();

//		type=array_exp_type(current->expr(0));
		//if (!(cur_exp->variant()==DEFINED_OP))
		if (!isSgArrayType(type))
		{   	*exp_res=cur_exp;
			//is not array result function.
printf("is not array type\n");
                       	return(scalarized_dim);
		}
		decided_dim=NOT_DECIDED;
//		type=array_exp_type(current->expr(0),&decided_dim);
		  // zheng.gb   type is the cuurent function's type.  1998/3/5
		  // it is wrong to get type from LHS
		{
		if (isSgArrayType(type)->getDimList() != NULL) decided_dim=DECIDED;
		}
                var_sym=get_temp_variable(hedr_stmt,type,IDSTR);
                decl_stmt=var_sym->makeVarDeclStmt();
                if (decided_dim==NOT_DECIDED)//allocatable array
                {       temp_exp=new SgExpression(ALLOCATABLE_OP,NULL,NULL,NULL)
;
                        decl_stmt->setExpression(2 , temp_exp);
                }

                last_decl=hedr_stmt->lastDeclaration();
                last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
                var_ref_exp=new SgVarRefExp(*var_sym);
		if (decided_dim==DECIDED){
			if (temp_array_list==NULL)
			{	temp_array_list=new SgExpression (EXPR_LIST,var_ref_exp,NULL,NULL);
			}
	           	else
			{  temp_array_list=new SgExpression(EXPR_LIST,var_ref_exp,temp_array_list,NULL);
			}
		}
                if (decided_dim==NOT_DECIDED)
                //allocate and deallocate space for the temporary variable.
		{	decided_dim=DECIDED;
                        type=array_exp_type(current->expr(0),&decided_dim);
                        allocate_stmt=new SgStatement(ALLOCATE_STMT);
                        deallocate_stmt=new SgStatement(DEALLOCATE_STMT);
                        ary_type=(SgArrayType*)type;
                        temp_exp=new SgExpression(ary_type->thetype->entry.ar_decl.ranges);
                        temp_exp=new SgExpression(EXPR_LIST,temp_exp,NULL,NULL);

                        temp_exp=new SgExpression(ARRAY_REF,temp_exp,NULL,var_sym);
                        temp_exp=new SgExpression(EXPR_LIST,temp_exp,NULL,NULL);
                        head_exp=temp_exp;
                        allocate_stmt->setExpression(0,head_exp);
                        control_parent=current->controlParent();
                        current->lexPrev()->insertStmtAfter(*allocate_stmt,*control_parent);
 
                        temp_exp1=new SgExpression(VAR_REF,NULL,NULL,var_sym);
                        temp_exp1=new SgExpression(EXPR_LIST,temp_exp1,NULL,NULL);
                        deallocate_stmt->setExpression(0,temp_exp1);
                        last_stmt=hedr_stmt->lastExecutable();
                        control_parent=last_stmt->controlParent();
                        last_stmt->insertStmtAfter(*deallocate_stmt,*control_parent);

                }

		ary_ref_exp=new SgArrayRefExp(*var_sym);
               	assign_stmt=new SgAssignStmt(*var_ref_exp,*(cur_exp));
		control_parent=current->controlParent();
               	//current->lexPrev()->insertStmtAfter(*assign_stmt,*control_parent);
                current->insertStmtBefore(*assign_stmt,*control_parent);

		total_dim=((SgArrayType*) type)->dimension();
		for (i_dim=0;i_dim<total_dim;i_dim++)
		{	temp_exp1=new SgValueExp(1);
       	        	index_exp=new SgVarRefExp(get_temp_index(index_var++,hedr_stmt,IDSTR)); 
			//temp_exp1=&((*temp_exp1)+(*index_exp));
			sub=&((*temp_exp1)+(*index_exp));
                       	//temp_exp=new SgArrayRefExp(*var_sym,*temp_exp1);
			ary_ref_exp->addSubscript(*sub);
			//((SgArrayRefExp*)var_ref_exp)->addSubscript(*sub);
			scalarized_dim++;
			*subscript=(SgSubscriptExp*)((SgArrayType *) type)->sizeInDim(i_dim);
		}
                *exp_res=ary_ref_exp;
	}//end of is_function
	else
	if (isBinaryOp(cur_exp))
	{	
		left_tree=cur_exp->lhs();
		right_tree=cur_exp->rhs();	
		if (left_tree)
		l_scalarized_dim=scalarize_exp(hedr_stmt,left_tree,&left_res,index_var,subscript,current);
		if (right_tree)
		r_scalarized_dim=scalarize_exp(hedr_stmt,right_tree,&right_res,index_var,subscript,current);
		cur_exp->setLhs(left_res);
		cur_exp->setRhs(right_res);
		*exp_res=cur_exp;
		if (l_scalarized_dim>r_scalarized_dim)
		scalarized_dim=l_scalarized_dim;
		else
		scalarized_dim=r_scalarized_dim;
		//scalarized_dim=max(l_scalarized_dim,r_scalarized_dim);
	}// end of binary operator
	else 
	if (isSgUnaryExp(cur_exp))
	{
		left_tree=cur_exp->lhs();
		if (left_tree)
		scalarized_dim=scalarize_exp(hedr_stmt,left_tree,&left_res,index_var,subscript,current);
		cur_exp->setLhs(left_res);
		*exp_res=cur_exp;
	}// end of unary operator
	else
	if (cur_exp->thellnd->variant==ARRAY_CONSTRUCTOR)
	{ 

		type=cur_exp->type();
		range=get_constructor_num(cur_exp);
                // add the dimmension declare !
                ((SgArrayType *)type)->addRange(*range);
		var_sym=get_temp_variable(hedr_stmt,type,IDSTR);
		var_ref_exp=new SgVarRefExp(*var_sym);
		if (temp_array_list==NULL)
		{	temp_array_list=new SgExpression (EXPR_LIST,var_ref_exp,NULL,NULL);;
		}
	           else
			{  temp_array_list=new SgExpression(EXPR_LIST,var_ref_exp,temp_array_list,NULL);
			}
		// make the stmt
		decl_stmt=var_sym->makeVarDeclStmt();
		exp1=decl_stmt->expr(0);
		exp2=exp1->lhs();
		exp3=&SgAssignOp(*exp2,*cur_exp);
		exp1->setLhs(*exp3);
		exp4=new SgExpression(PARAMETER_OP);
		expr_list=new SgExprListExp(*exp4);
		decl_stmt->setExpression(2,expr_list);
		// insert into the program
		last_decl=hedr_stmt->lastDeclaration();
		last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
		temp_exp1=new SgValueExp(1);
        	index_exp=new SgVarRefExp(get_temp_index(index_var,hedr_stmt,IDSTR));
		temp_exp1=&((*temp_exp1)+(*index_exp));
		temp_exp=new SgArrayRefExp(*var_sym,*temp_exp1);
		*exp_res=temp_exp;
		*subscript=new SgSubscriptExp(*default_lsub,*range,*base_step);
		scalarized_dim++;
	}//end of ARRAY CONSTRUCTOR
	else 
	if (isSgArrayType(cur_exp->type()))
	//array reference
        {
		scalarize_AryRef_exp(hedr_stmt,cur_exp,0,exp_res,index_var,subscript,&scalarized_dim,current);
        }
	else
	//scalar
	{	*exp_res=cur_exp;
		scalarized_dim=0;
	}
	return(scalarized_dim);
}

void    align_temp_var(SgStatement *hedr_stmt,SgExpression * index_trip,
			SgExpression *exp_hedr, SgExpression * temp_list) 
{
	SgStatement	*lastdeclare,*temp_stmt;
	SgExpression	*cur_exp,*cur_index,*exp;
	SgExpression	*ll1,*ll3_last,*cur_ll3,*ll3_hedr;
	SgExpression	*index_list,*hedr_index,*last_index;
	SgSymbol	*array_name=exp_hedr->symbol();
	
	lastdeclare=hedr_stmt->lastDeclaration();
//last decalration statement
	hedr_index=NULL;
	cur_index=index_trip->lhs();
//forall index header expression
	while(cur_index!=NULL)
	{ 	cur_exp=cur_index->lhs()->lhs();
	  	cur_index=cur_index->rhs();
	 	index_list=new SgExpression (EXPR_LIST,cur_exp,NULL,NULL) ;	
	 	if (hedr_index==NULL)  { last_index=hedr_index=index_list; }
	  	else
		{ 	last_index->setRhs(index_list);
	  		last_index=index_list;
		}
	}
	if (!hedr_index) return;
	while (temp_list!=NULL)
//declare ALIGN statement for every temporary variable in order
	{	cur_exp=temp_list->lhs();
		//current temporary variable to be aligned
		temp_list=temp_list->rhs();
		ll1=new SgExpression(EXPR_LIST,cur_exp->copyPtr(),NULL,NULL);	
		cur_index=hedr_index;//forall header index
		ll3_hedr=NULL;
		exp=exp_hedr;//lhs of the assign statement
		if (exp->variant()!=ARRAY_REF) {return; }
		else
		{	exp =exp->lhs();
			while ((exp!=NULL ) && (cur_index!=NULL))	
		     	{	if (contain(exp->lhs(),cur_index->lhs()->symbol())==0)
				{ 	cur_ll3=new SgExpression (STAR_OP,NULL,NULL,NULL);
				}
				else  
		    		{	//??cur_ll3=new SgExpression(exp->lhs()->thellnd); 
					cur_ll3=exp->lhs()->copyPtr();
					cur_ll3=&((*cur_ll3)-(default_lsub->copy()));
					cur_index=cur_index->rhs();
			    	}	
				cur_ll3=new SgExpression(EXPR_LIST,cur_ll3,NULL,NULL);
				exp=exp->rhs();
				if (ll3_hedr==NULL)
				{  ll3_hedr=ll3_last=cur_ll3;
				}
			  	else
			   	{	ll3_last->setRhs(cur_ll3);
					ll3_last=cur_ll3;
			   	}

		     }//end of while
		}// end of else
		ll3_hedr= new SgExpression (ARRAY_REF,ll3_hedr,NULL,array_name);
		ll3_hedr=new SgExpression(ALIGN_WITH_OP,NULL,ll3_hedr,NULL);
		ll3_hedr=new SgExpression(ALIGN_OP,hedr_index,ll3_hedr,NULL);
		ll3_hedr=new SgExpression(EXPR_LIST,ll3_hedr,NULL,NULL);
		temp_stmt=new SgStatement(ALIGN_DECL,NULL,NULL,ll1,NULL,ll3_hedr);
		lastdeclare->insertStmtAfter(*temp_stmt);
	}
}


int	contain(SgExpression *exp,SgSymbol *sym)
{	int	yes=0;
	SgExpression	*cur_exp=exp,*value;

	while (cur_exp)
	{ if (value=cur_exp->lhs())
	     if (value->symbol()==sym)  
		{ return(1);}
	 cur_exp=cur_exp->rhs();
	} 
	return(yes);
}

//
//if the expression have two parts.
//
int	isBinaryOp(SgExpression *exp)
{	
	int	variant=exp->variant();
	
	if (variant==MINUS_OP)
		if (!exp->rhs()) return 0;
		else return 1;

	if ((variant>=328) && (variant  <=346))
	{
		return (1); 
	}
	else { return (0); }
}
//
//if the expression is function call ,intrinsic function,
//or user defined operator include binary or unary.
//
int is_function(SgExpression *exp)
{
	if (isSgFunctionCallExp(exp)) return 1;

	switch (exp->variant()) {
	case INTRIN_FUNC_CALL:
	case FUNC_CALL:
	case DEFINED_OP:
		return 1;
	}
	return 0;
}
//
//if we need to transform the statement
//
int if_trans(SgStatement *stmt)
{
	SgExpression  *rhs=stmt->expr(1);	

	if (is_function(rhs))
	{
		return 0;
	}
	return 1;
}

//
//given an array constructor ,return the number of the array constructor
//
SgExpression * get_constructor_num(SgExpression * constructor_exp)
{   
	SgExpression * lhs, *rhs;
	rhs=constructor_exp->rhs();
	return(ac_value_list(rhs));

}
//
//calculate the implied do variable repeat how many times
//see Fortran specification R433
//
SgExpression *ac_implied_do(SgExpression * exp)
{

	SgExpression * lhsresult,*rhsresult,*result,*lhs,*rhs,*temp;
	SgExpression * lbound, *ubound,* step;
	lhs=exp->lhs();
	rhs=exp->rhs();
	lhsresult=ac_value_list(lhs);
	temp=rhs->rhs();
	if (temp)
		step=temp;
	else
		step=base_step;
	temp=rhs->lhs();
	lbound=temp->lhs();
	ubound=temp->rhs();
	rhsresult=&(((*ubound)-(*lbound))/(*step)+(*base_step));
	result=&((*lhsresult)*(*rhsresult));
	return(result);

}
//
//calculate the value list contains how many elements
//see Fortran specification R432
//
SgExpression * ac_value_list(SgExpression * exp)
{
        SgExpression * lhsresult,*rhsresult,*result,*lhs,*rhs;
	lhs=exp->lhs();
	rhs=exp->rhs();
	if (lhs->thellnd->variant==IMPLIED_DO)
	lhsresult=ac_implied_do(lhs);
	else
	lhsresult=base_step;
	if (rhs)
	{	rhsresult=ac_value_list(rhs);
		result=&((*lhsresult)+(*rhsresult));
	}
	else
	result=lhsresult;
	return(result);
}
	


SgType * array_exp_type(SgExpression * exp,int * flag)
{
	SgVariableSymb	*array_name;//the rightest variable name or array
					// subobject name.
	SgSubscriptExp	*subscript;//the subscript expression of i dimension
	SgArrayType	*array_type;//the type of array name
	SgType		*return_type;
	SgExpression	*expr_list;//subscript expression list
	SgExpression    *lbound , *ubound, *step;// the low bound,up bound,
						// and step of i dimension
	int 		i_dim;//the i dimension of array name
	int		total_dim;//how many dimension of array name
	int		scalar_or_array;
	SgExpression 	*cur_exp=exp;//the expression to be scalarized
	SgExpression	*rec_exp;//record reference expression	
	SgExpression	*temp1,*temp;
    	SgType          *type;
	SgVariableSymb	*temp_sym;
	SgExpression	*exp1,*exp2,*exp3,*exp4;
	SgExprListExp	*exp5;
	SgVarRefExp	*var_exp;
	SgExpression	*ary_sub,*ary_sub_res;//used when array subscript is int expression
	SgExpression	*range;

	// reduce RECORD_REF to ARRAY_REF,get the rightest expression if record
	if (isSgRecordRefExp(cur_exp)) {
		int the_variant;
		the_variant=cur_exp->lhs()->type()->variant();
		while (cur_exp->rhs()) {
			if (the_variant!=T_ARRAY)
			{	
 				cur_exp=cur_exp->rhs();
                		the_variant=cur_exp->lhs()->type()->variant();
			}else
			{  break;
			}
		}
		rec_exp=cur_exp;              // save this pointer !!
		cur_exp=cur_exp->lhs();
		// this means the cur_exp point to the RECORD_REF and the record name itself is an arraytype 
		if (rec_exp == exp) {
			rec_exp=exp->lhs();
			//cur_exp=rec_exp->lhs();
			cur_exp=rec_exp;
		}
		// now RECORD_REF is reduced to VAR_REF or ARRAY_REF in cur_exp.
	}
	expr_list=cur_exp->lhs();                   // subscipt list
	ASSERT(cur_exp->symbol());
	array_name=(SgVariableSymb *) (cur_exp->symbol());
	array_type=(SgArrayType *) (array_name->type());
//	((SgArrayType*)return_type)->setBaseType(*(array_type->baseType()));
	return_type=new SgArrayType(*(array_type->baseType()));
	//return_type=cur_exp->type();
	total_dim=array_type->dimension();               // dimension
	int return_dim=0;
	for (i_dim=0;i_dim<total_dim;i_dim++) {
	  subscript=(SgSubscriptExp *)array_type->sizeInDim(i_dim);
	  if (isSgVarRefExp(cur_exp)) {
	  	// form like A,A%B,...
		ubound=(subscript->ubound());
		lbound=(subscript->lbound());
		step=(subscript->step());
	        if (lbound==NULL||ubound==NULL)
//		if (ubound==NULL)
		{	
			if (*flag==NOT_DECIDED)
			{	range=new SgExpression(RANGE_OP,NULL,NULL,NULL);
                        	range=new SgExpression(DDOT,range,NULL,NULL);
			}
			else
			{
				lbound=new SgValueExp(i_dim+1);
				lbound=new SgExpression(EXPR_LIST,lbound,NULL,NULL);
                        	lbound=new SgExpression(EXPR_LIST,cur_exp,lbound,NULL);
				temp_sym=new  SgVariableSymb("lbound");
				lbound->setType(*SgTypeInt());
                        	lbound=new SgExpression(INTRIN_FUNC_CALL,lbound,NULL,temp_sym);
                        	ubound=new SgValueExp(i_dim+1);
                        	ubound=new SgExpression(EXPR_LIST,ubound,NULL,NULL);
                        	ubound=new SgExpression(EXPR_LIST,cur_exp,ubound,NULL);
                        	temp_sym=new  SgVariableSymb("ubound");
                        	ubound=new SgExpression(INTRIN_FUNC_CALL,ubound,NULL,temp_sym );
				ubound->setType(*SgTypeInt());

				step=base_step;
                		range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
				range=new SgExpression(RANGE_OP,NULL,range,NULL);
                		range=new SgExpression(DDOT,range,NULL,NULL);
				*flag=DECIDED;
			}

		}else
 	        {	
			range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
			range=new SgExpression(RANGE_OP,NULL,range,NULL);
                	range=new SgExpression(DDOT,range,NULL,NULL);
                        *flag=DECIDED;
		}
                ((SgArrayType *)return_type)->addRange(*range);
		return_dim++;

	  }//end of VarRefExp
	  else 
	  if (expr_list->lhs()->variant()==DDOT){
		// form like A(1:10:2),A(1:10),A(1:),A(:10:2),A(1::2),A(::2),...

		temp=expr_list->lhs();//DDOT expression
		temp1=temp->rhs();//step expr
		if (temp1) {step=temp1;}//initial value
		    else {step=base_step;}//default
		temp=temp->lhs();//RANGE expression
		temp1=temp->lhs();//low bound expression
		if (temp1) {lbound=temp1;}//initial value
		    else {lbound=(subscript->lbound());}//defined array variable's lbound
		  temp1=temp->rhs();//up bound expression
		   if (temp1)  { ubound=temp1; }//initial value
		     else 	{ubound=(subscript->ubound());}//defined array variable's ubound
		expr_list=expr_list->rhs();// expr_list now point to the next dimension
 	
                range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
		range=new SgExpression(RANGE_OP,NULL,range,NULL);
               	range=new SgExpression(DDOT,range,NULL,NULL);
                ((SgArrayType *)return_type)->addRange(*range);
		return_dim++;
                *flag=DECIDED;


	  }//end of DDOT
	  else
	  {

		  // array or scalar expression:
		  // Vector subscript like A((/1,2,3/)),scalar subscript like A(i,:)
		  // array expression like A(B+C),B and C are one dimension array,vector subscript is
		  //one dimension int array expression.
		  ary_sub=expr_list->lhs();
		  expr_list=expr_list->rhs();//point to the next dimension subscript
		  scalar_or_array=get_subscript(ary_sub,&subscript,flag);
		  if (scalar_or_array==0){
			
		  	continue;
		  }else
		  {
			//ary_sub is array expression
			//specification restrict the ary_sub must be rank=1 integer array expression
			//only here we use the subscript calculated by  scalarize_exp(....)
			ubound=(subscript->ubound());
		  	lbound=(subscript->lbound());
		      	step=(subscript->step());
 	                range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
			range=new SgExpression(RANGE_OP,NULL,range,NULL);
               		range=new SgExpression(DDOT,range,NULL,NULL);
        	        ((SgArrayType *)return_type)->addRange(*range);
			return_dim++;
		  }
                  *flag=DECIDED;
	  }//end of int_expr subscript

    	}  // end of for loop
     	return_type->thetype->entry.ar_decl.num_dimensions = return_dim;
	return return_type;
}

int get_subscript(SgExpression * exp,SgSubscriptExp** subscript,int *flag)
{

	SgExpression	*left_tree,*right_tree;
	SgExpression	*cur_exp=exp;
	int		l_dim=0,r_dim=0;
	SgArrayType	*array_type;
	SgExpression	*range;
	
	if (isBinaryOp(cur_exp))
	{	
		left_tree=cur_exp->lhs();
		right_tree=cur_exp->rhs();	
		if (left_tree)
		l_dim=get_subscript(left_tree,subscript,flag);
		if (l_dim!=0) return(l_dim);
		if (right_tree)
		r_dim=get_subscript(right_tree,subscript,flag);
		return (r_dim);
	}// end of binary operator
	else 
	if (isSgUnaryExp(cur_exp))
	{
		left_tree=cur_exp->lhs();
		if (left_tree)
		l_dim=get_subscript(left_tree,subscript,flag);
	}// end of unary operator
	else
	if (cur_exp->thellnd->variant==ARRAY_CONSTRUCTOR)
	{ 

		range=get_constructor_num(cur_exp);
		*subscript=new SgSubscriptExp(*default_lsub,*range,*base_step);
		l_dim=1;
	}//end of ARRAY CONSTRUCTOR
	else 
	if (isSgArrayType(cur_exp->type()))
	//array reference
        {
		array_type=(SgArrayType*)array_exp_type(cur_exp,flag);
		*subscript=(SgSubscriptExp *)(array_type->sizeInDim(0));
		l_dim=1;
        }
	else
	//scalar
	{
		l_dim=0;
	}
	*flag=DECIDED;
	return(l_dim);
}

int  add_align_for_tmp(SgStatement * hedr_stmt,SgSymbol *tmp,SgExpression *argexp)
{  
/*
    int result=0;
    if (argexp==NULL) return(0);
    printf("\nargexp->variant() =%d",argexp->variant() );
    if (argexp->variant() ==ARRAY_REF)
    {
        printf("\n to here");
        return(1);
    }
    result=add_align_for_tmp(hedr_stmt,tmp, argexp->lhs());
    if (result==1) return(1);
    result=add_align_for_tmp(hedr_stmt,tmp, argexp->rhs());
    if (result==1) return(1);
    return(0);

*/
    int result=0;
    if (argexp==NULL) return(0);
    //printf("\n enter to here");
    SgArrayType *tmpType = isSgArrayType(tmp->type());
    if (tmpType == NULL) return 0;

    if ( argexp->variant() == VAR_REF)
    {
        result=align_where_condition(hedr_stmt,tmp, argexp->symbol());
        return result==1 ?1:0;
    }
    if (  argexp->variant() == ARRAY_REF )
    {
	SgArrayRefExp *array = isSgArrayRefExp(argexp);
	SgArrayType *arraytype = isSgArrayType(argexp->symbol()->type());
	// tmp's type must is same as arg array's type
	if (arraytype && arraytype->dimension() == tmpType->dimension())
        	result=align_where_condition(hedr_stmt,tmp, argexp->symbol());
	else 
		return 0;
        return result==1 ?1:0;
    }
    result=add_align_for_tmp(hedr_stmt,tmp, argexp->lhs());
    if (result==1) return(1);
    result=add_align_for_tmp(hedr_stmt,tmp, argexp->rhs());
    if (result==1) return(1);
    return(0);

}            

